		.title	ax - lx/zx/tx selector

program:	.reg	'ax'
version:	.reg	'0.10'
date:		.reg	'96/10/20'
author:		.reg	'Ԃ'


* Include File -------------------------------- *

		.include	doscall.mac


* Fixed Number -------------------------------- *

		.ifndef	__CRLF__
LF:		.equ	$0a
		.else
LF:		.reg	$0d,$0a
		.endif

EXT_BUF_SIZE:	.equ	8


* Offset Table -------------------------------- *

		.offset	0
ArgPtr:
		.ds.l	1
cmdline_bak:
		.ds.l	1
cmdline_buf:
ext_buffer:
		.ds.b	EXT_BUF_SIZE
execfile_buf:
		.ds.b	90
		.even
WORK_SIZE:


* Text Section -------------------------------- *

		.cpu	68000
		.text

start_:
		bra	@f
hupair_mark:
		.dc.b	'#HUPAIR',0
@@:
		pea	(work_top-start_+$f0+WORK_SIZE)
		pea	(16,a0)
		DOS	_SETBLOCK
		addq.l	#8,sp
		tst.l	d0
		bmi	memory_error

		lea	(work_top,pc),a6
		move.l	a2,(cmdline_bak,a6)
		pea	(1,a2)
		bsr	GetArgCharInit
		addq.l	#4,sp
arg_loop:
		bsr	GetArgChar
		tst.l	d0
		ble	print_usage
		cmpi.b	#'-',d0
		bne	found_arcfile
@@:
		bsr	GetArgChar		;IvV΂
		tst.l	d0
		bmi	arg_loop
		beq	print_usage
		bra	@b
found_arcfile:
		lea	(ext_buffer,a6),a0
	.rept	EXT_BUF_SIZE/4
		clr.l	(a0)+
	.endm
		move.b	d0,-(a0)		;ꕶ
arcfile_loop:
		bsr	GetArgChar
		tst.l	d0
		ble	arcfile_end

		lea	(ext_buffer,a6),a0
		moveq	#(EXT_BUF_SIZE-1)-1,d1
@@:		move.b	(1,a0),(a0)+
		dbra	d1,@b
		move.b	d0,(a0)
		bra	arcfile_loop
arcfile_end:
		lea	(ext_table_lha,pc),a0
		bsr	check_ext
		beq	type_lha
		lea	(ext_table_zip,pc),a0
		bsr	check_ext
		beq	type_zip
		lea	(ext_table_tar,pc),a0
		bsr	check_ext
		beq	type_tar
		lea	(ext_table_gzip,pc),a0
		bsr	check_ext
		beq	type_gzip
		bra	type_other
type_other:
		moveq	#'x',d0
		bra	@f
type_lha:
		moveq	#'l',d0
		bra	@f
type_zip:
		moveq	#'z',d0
		bra	@f
type_gzip:
		bsr	add_cmdline_z
type_tar:
		moveq	#'t',d0
		bra	@f
@@:
		lea	(execfile_buf,a6),a0
		move.l	#'x'<<16,(a0)
		move.b	d0,(a0)

		clr.l	-(sp)			;env
		pea	(cmdline_buf,a6)
		move.l	a0,-(sp)		;execfile
		move	#2,-(sp)		;pathchk
		DOS	_EXEC
		lea	(14,sp),sp
		tst.l	d0
		bmi	exec_error

		clr.l	-(sp)
		move.l	(cmdline_bak,a6),-(sp)
		move.l	a0,-(sp)
		move	#1,-(sp)		;loadonly
		DOS	_EXEC
		lea	(14,sp),sp
		tst.l	d0
		bmi	exec_error

		move.l	a4,-(sp)
		move	#4,-(sp)		;execonly
		DOS	_EXEC
		addq.l	#6,sp
*		bsr	mfree_cmdline_buf
		move	d0,-(sp)
		DOS	_EXIT2

check_ext:
		moveq	#-2,d0
@@:
		addq	#1,d0			;-1
		tst.b	(a0)+
		bne	@b
		lea	(-1,a0),a1
		lea	(ext_buffer+EXT_BUF_SIZE,a6),a2
@@:
		moveq	#$20,d1
		or.b	-(a2),d1
		cmp.b	-(a1),d1
		dbne	d0,@b
		bne	check_ext_next
		cmpi.b	#'.',-(a2)
		bne	check_ext_next

		moveq	#0,d0
		rts
check_ext_next:
		tst.b	(a0)
		bne	check_ext
		moveq	#-1,d0
		rts

add_cmdline_z:
		movea.l	(cmdline_bak,a6),a0
		lea	(1,a0),a1
@@:
		tst.b	(a1)+
		bne	@b
		move.l	a1,d1
		sub.l	a0,d1			;R}hCɕKvȃ

		moveq	#0,d2
		subq.l	#8,a0
		lea	(hupair_mark,pc),a2
		cmpm.l	(a0)+,(a2)+
		bne	not_hupair
		cmpm.l	(a0)+,(a2)+
		bne	not_hupair
@@:
		tst.b	(a1)+
		bne	@b
		move.l	a1,d1
		sub.l	a0,d1
		addq.l	#8,d1			;HUPAIȐꍇ
		moveq	#-1,d2
not_hupair:
		addq.l	#3,d1			;strlen("-z ")
		move.l	d1,-(sp)
		DOS	_MALLOC
		move.l	d0,(sp)+
		bmi	memory_error

		move.l	d0,a0
		movea.l	(cmdline_bak,a6),a1
		tst	d2
		beq	not_hupair2

		move.l	(-8,a1),(a0)+
		move.l	(-4,a1),(a0)+
not_hupair2:
		move.l	a0,(cmdline_bak,a6)

		move.b	(a1)+,d0		;
		addq.b	#3,d0
		bcc	@f
		scs	d0			;255ȏ255ɂ
@@:		move.b	d0,(a0)+

		move.b	#'-',(a0)+
		move.b	#'z',(a0)+
		move.b	#' ',(a0)+
@@:
		move.b	(a1)+,(a0)+		;
		bne	@b
		tst	d2
		beq	not_hupair3
@@:
		move.b	(a1)+,(a0)+		;argv[0]
		bne	@b
not_hupair3:
		rts

*mfree_cmdline_buf:
*		move.l	d0,-(sp)
*		clr.l	-(sp)
*		DOS	_MFREE
*		addq.l	#4,sp
*		move.l	(sp)+,d0
*		rts

* G[ ---------------------------------- *

memory_error:
		lea	(memory_err_mes,pc),a0
		bra	@f
exec_error:
		lea	(exec_err_mes,pc),a0
		bra	@f
@@:
		move	#2,-(sp)		;STDERR
		move.l	a0,-(sp)
		DOS	_FPUTS
		addq.l	#6,sp
		bra	@f

print_usage:
		pea	(usage_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
@@:
		move	#1,-(sp)
		DOS	_EXIT2


* Sub Routine --------------------------------- *

GetArgChar::
		movem.l	d1/a1,-(sp)
		moveq	#0,d0
		move.b	(ArgPtr,a6),d0
		movea.l	(ArgPtr,a6),a1
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_abort
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.l	a1,(ArgPtr,a6)
		move.b	d1,(ArgPtr,a6)
GetArgChar_abort:
		movem.l	(sp)+,d1/a1
		rts
GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next
GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		subq.l	#1,a1
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_end

GetArgCharInit::
		move.l	a1,-(sp)
		movea.l	(8,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		subq.l	#1,a1
		move.l	a1,(ArgPtr,a6)
		movea.l	(sp)+,a1
		rts


* Data Section -------------------------------- *

usage_mes:
		.dc.b	program,' - lx/zx/tx selector  version ',version,'  ',date,' ',author,LF
		.dc.b	'usage: ',program,' [<switch>] <arc-file> [<ext-file> cc ]',LF
		.dc.b	0

memory_err_mes:
		.dc.b	program,': mۂł܂.',LF,0
exec_err_mes:
		.dc.b	program,': R}hsł܂.',LF,0

ext_table_lha:
		.dc.b	'lzh',0,'lha',0,'exe',0,'x',0
*		.dc.b	'lzs',0,'com',0,'r',0
		.dc.b	0
ext_table_zip:
		.dc.b	'zip',0
		.dc.b	0
ext_table_tar:
		.dc.b	'tar',0,'tgz',0,'tar.gz',0
*		.dc.b	'taz',0,'tar.z',0
		.dc.b	0
ext_table_gzip:
		.dc.b	'gz',0
*		.dc.b	'z',0
		.dc.b	0


		.even
work_top:

		.end

* End of File --------------------------------- *
